﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using View;

namespace FlowsManager
{
    /// <summary>
    /// Class that represents problem inside home
    /// </summary>
    abstract class ProblematicSituation
    {
        /// <summary>
        /// State that causes this problem (problematic situation)
        /// </summary>
        protected virtual VState State
        {
            get
            {
                return this.state;
            }
        }

        public virtual string Description
        {
            get
            {
                return "Problematic situation";
            }
        }

        protected VState state;

        public ProblematicSituation(VState _vState)
        {
            this.state = _vState;
        }
    }
}
