﻿//15.03.2013
//Kamil.Hawdziejuk@uj.edu.pl

using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using FlowsManager.Problems;

namespace FlowsManager.Validators
{
    /// <summary>
    /// Validates if the limit was exceeded
    /// </summary>
    class LimitValidator : IValidator
    {
        private double _maxValue;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="_percentLimit">Fraction [0,1]</param>
        public LimitValidator(double maxValue)
        {
            this._maxValue = maxValue;
        }

        public ProblematicSituation Validate(View.VState state)
        {
            if (state.ExactValue <= this._maxValue)
            {
                return null;
            }
            else
            {
                return new ExceedSituation(state, this._maxValue, state.ExactValue);
            }
        }

        public string Name
        {
            get { return "LimitValidator"; }
        }

        public virtual SituationPriority Priority
        {
            get
            {
                return SituationPriority.Warning;
            }
        }
    }
}
